diff -r 1e55e1aa8b7f sys/netinet/mptcp_subr.c
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp_subr.c	Fri Jul 11 13:32:06 2014 +1000
@@ -0,0 +1,1920 @@
+/*-
+ * Copyright (c) 2012-2013
+ * 	Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams and
+ * Lawrence Stewart, made possible in part by a gift from The Cisco University
+ * Research Program Fund, a corporate advised fund of Silicon Valley Community
+ * Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include "opt_compat.h"
+#include "opt_inet.h"
+#include "opt_inet6.h"
+#include "opt_ipsec.h"
+#include "opt_tcpdebug.h"
+
+#include <sys/malloc.h>
+#include <sys/mbuf.h>
+#include <sys/param.h>
+#include <sys/queue.h>
+#include <sys/systm.h>
+#include <sys/callout.h>
+#include <sys/hhook.h>
+#include <sys/kernel.h>
+#include <sys/khelp.h>
+#include <sys/kdb.h>
+#include <sys/lock.h>
+#include <sys/rwlock.h>
+#include <sys/sysctl.h>
+#include <sys/sbuf.h>
+#include <sys/taskqueue.h>
+#include <sys/jail.h>
+
+#ifdef INET6
+#include <sys/domain.h>
+#endif
+#include <sys/priv.h>
+#include <sys/proc.h>
+#include <sys/sockbuf.h>
+#include <sys/socket.h>
+#include <sys/socketvar.h>
+#include <sys/protosw.h>
+#include <sys/random.h>
+
+/* for SCTP auth functions */
+#include <crypto/sha1.h>
+
+/* for checking interface status */
+#include <net/if.h>
+
+#include <netinet/in.h>
+#include <netinet/in_pcb.h>
+#include <netinet/tcp_var.h>
+#include <netinet/tcp_timer.h>
+#include <netinet/tcp_fsm.h>
+
+#include <netinet/mptcp_var.h>
+
+/* for SCTP auth functions */
+#include <netinet/sctp_pcb.h>
+#include <netinet/sctp_auth.h>
+#include <netinet/sctp_constants.h>
+
+#include <machine/stdarg.h>
+
+/* Declare sysctl tree and populate it. */
+SYSCTL_NODE(_net_inet_tcp, OID_AUTO, mptcp, CTLFLAG_RW, NULL,
+    "Mulitpath TCP related settings");
+
+VNET_DEFINE(int, linux_compat) = 1;
+#define	V_mptcp_linux_compat	VNET(mptcp_linux_compat);
+SYSCTL_VNET_INT(_net_inet_tcp_mptcp, OID_AUTO, linux_compat, CTLFLAG_RW,
+    &VNET_NAME(linux_compat), 0,
+    "Subtle changes for linux mptcp interop");
+
+VNET_DEFINE(int, max_subflows) = 8;
+#define	V_mptcp_max_subflows	VNET(mptcp_max_subflows);
+SYSCTL_VNET_INT(_net_inet_tcp_mptcp, OID_AUTO, max_subflows, CTLFLAG_RW,
+    &VNET_NAME(max_subflows), 0,
+    "Maximum number of subflows per Multipath TCP Connection");
+
+VNET_DEFINE(int, single_packet_maps) = 1;
+#define	V_mptcp_single_packet_maps	VNET(mptcp_single_packet_maps);
+SYSCTL_VNET_INT(_net_inet_tcp_mptcp, OID_AUTO, single_packet_maps, CTLFLAG_RW,
+    &VNET_NAME(single_packet_maps), 0,
+    "DSN Maps cover a single packet only");
+
+
+struct debug_class {
+	char class[32];
+	int verbosity;
+	int loglevelexclusive;
+};
+
+uint32_t mp_active_debug_classes;
+
+struct debug_class debug_classes[] = {
+		{.class = "MPSESSION"},
+		{.class = "DSMAP"},
+		{.class = "SBSTATUS"},
+		{.class = "REASS"}
+};
+
+#define	N_DEBUGCLASSES (sizeof(debug_classes)/sizeof(struct debug_class))
+
+
+static void mp_drop_dup_maps(struct mpcb *mp);
+
+//struct ds_map*
+//mp_get_dsmap(struct tcpcb *tp, uint64_t ds_ack_num);
+
+/* keeping track of addresses added via sysctl:
+ * net.inet.tcp.mptcp.mp_addresses. Though we start at '1' as the 'master'
+ * address is included.
+ */
+int mp_address_count = 1;
+struct sockaddr_storage mp_usable_addresses[MAX_ADDRS];
+
+/* Initialise extern variables that store addresses */
+struct sockaddr_storage mp_path_manager[MAX_ADDRS];
+
+int in_def_drop = 0;
+
+#define MSBIT_CHECK 0x80000000
+
+static void	mp_update_recwin(struct mpcb *mp);
+//static void mp_alloc_pcbs(struct sockaddr_storage, struct inpcb *sf_inp, struct mpcb *mp);
+
+
+/* iterate through the list of tcpcbs and print the DSN, T_SEQ of the segs
+ * in reassembly
+ * Calling from the debugger so not worried about locking
+ */
+void
+mp_print_reass_lists(struct mpcb *mp) {
+	struct tcpcb *sf_tp;
+	struct tseg_qent *q = NULL;
+	int index = 0;
+
+//	mp_print_sqns(mp);
+
+	SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+		index = 0;
+		TAILQ_FOREACH(q, sf_tp->t_segq, tqe_q) {
+			printf("%d: DSN: %u, TSEQ: %u, len %d\n", index,
+			    (uint32_t) q->tqe_dsn, q->tqe_th->th_seq, q->tqe_len);
+			    index++;
+		}
+		printf("----\n");
+	}
+}
+
+/* print the ds_level sequence numbers */
+void
+mp_print_sqns(struct mpcb *mp) {
+	printf("ds_rcv_nxt: %u\n", (uint32_t) mp->ds_rcv_nxt);
+}
+
+/* print rcvd mappings */
+void
+mp_print_maps(struct mpcb *mp) {
+
+}
+
+void
+mp_debug(uint32_t log_class, int msg_verbosity, uint32_t flags, char * fmt, ...) {
+	va_list ap;
+	int effective_verbosity, i, loglevelexclusive;
+
+	effective_verbosity = 0;
+
+	if (log_class & mp_active_debug_classes) {
+	// calculate shift index (index of class into array)
+		i = 0;
+		loglevelexclusive = 0;
+		while(log_class >= 1) {
+			if (log_class & 0x1) {
+				effective_verbosity = max(debug_classes[i].verbosity, effective_verbosity);
+				loglevelexclusive += debug_classes[i].loglevelexclusive;
+			}
+			log_class >>= 1;
+			i++;
+		}
+
+		if	((loglevelexclusive && msg_verbosity == effective_verbosity) ||
+				(!loglevelexclusive && msg_verbosity <= effective_verbosity)) {
+			va_start(ap, fmt);
+			vprintf(fmt, ap);
+			va_end(ap);
+		}
+	}
+}
+
+/*
+ * Sysctl handler to show and change slave subflow addresses
+ */
+static int
+mp_addresses(SYSCTL_HANDLER_ARGS)
+{
+	char *straddr;
+	struct sbuf *s;
+	void *addr;
+	char inet_buf[64];
+	int error, i, ret;
+
+	error = 0;
+
+	if (req->newptr == NULL) {
+
+		s = sbuf_new_for_sysctl(NULL, NULL, 300, req);
+		if (s == NULL)
+			return (ENOMEM);
+
+		/* Start at i = 1 as the 'master' address is always included
+		 * by default */
+		for (i = 1; i < mp_address_count; i++) {
+			switch (mp_usable_addresses[i].ss_family) {
+				case AF_INET:
+					addr = &((struct sockaddr_in *)
+					    &mp_usable_addresses[i])->sin_addr;
+					break;
+				case AF_INET6:
+					addr = &((struct sockaddr_in6 *)
+					    &mp_usable_addresses[i])->sin6_addr;
+					break;
+				default:
+					return (EINVAL);
+			}
+
+			inet_ntop(mp_usable_addresses[i].ss_family, addr, inet_buf,
+			    mp_usable_addresses[i].ss_len);
+			sbuf_cat(s, inet_buf);
+			if (i < (mp_address_count - 1))
+				sbuf_cat(s, " ");
+		}
+
+		error = sbuf_finish(s);
+		sbuf_delete(s);
+	} else {
+		i = 1;
+		while ((straddr = strsep((char **)&req->newptr, " "))
+			!= NULL && i < MAX_ADDRS && !error) {
+			ret = inet_pton(AF_INET6, straddr,
+			    &((struct sockaddr_in6 *)&mp_usable_addresses[i])->sin6_addr);
+			if (ret == 1) {
+				mp_usable_addresses[i].ss_family = AF_INET6;
+				mp_usable_addresses[i].ss_len = sizeof(struct sockaddr_in6);
+			} else if (ret == 0) {
+				ret = inet_pton(AF_INET, straddr,
+				&((struct sockaddr_in *)&mp_usable_addresses[i])->sin_addr);
+				if (ret == 1) {
+					mp_usable_addresses[i].ss_family = AF_INET;
+					mp_usable_addresses[i].ss_len = sizeof(struct sockaddr_in);
+				}
+			}
+
+			if (ret < 1) {
+				char *zero = "0";
+				mp_address_count = 1; //XXXNJW: Shouldn't be reading into mp_usable_addresses directly...
+				if (strcmp(straddr, zero) == 0)
+					return(0);
+				error = EINVAL;
+			}
+			i++;
+		}
+
+		if (!error) {
+			if (i == mp_address_count)
+				error = E2BIG;
+			else
+				mp_address_count = i;
+		}
+	}
+
+	return (error);
+}
+
+/*
+ * Sysctl handler for setting debug output levels for mp
+ */
+static int
+mp_debug_sysctl_handler(SYSCTL_HANDLER_ARGS)
+{
+	struct sbuf *s;
+	int error, i;
+
+	error = 0;
+
+	if (req->newptr == NULL) {
+		s = sbuf_new_for_sysctl(NULL, NULL, 300, req);
+		if (s == NULL)
+			return (ENOMEM);
+
+		for(i = 0; i < N_DEBUGCLASSES; i++) {
+				if (i > 0)
+					sbuf_putc(s, ',');
+				sbuf_printf(s, "%s:%c%d", debug_classes[i].class,
+					debug_classes[i].loglevelexclusive ? '=' : '*',
+					debug_classes[i].verbosity);
+		}
+
+		error = sbuf_finish(s);
+		sbuf_delete(s);
+	} else {
+		char *class, *pair;
+
+		while ((pair = strsep(((char **)&req->newptr), ",")) != NULL) {
+			class = strsep(&pair, ":");
+			for(i = 0; i < N_DEBUGCLASSES; i++) {
+				if (strcmp(class, debug_classes[i].class) == 0
+					|| strcmp(class, "ALL") == 0) {
+					if (pair[0] == '=') {
+						debug_classes[i].loglevelexclusive = 1;
+						pair++;
+					} else {
+						if (pair[0] == '*')
+							pair++;
+						debug_classes[i].loglevelexclusive = 0;
+					}
+					debug_classes[i].verbosity = strtol(pair, NULL, 10);
+					if (debug_classes[i].verbosity == 0)
+						mp_active_debug_classes &= ~(1<<i);
+					else
+						mp_active_debug_classes |= 1<<i;
+				}
+			}
+		}
+	}
+
+	return (error);
+}
+
+/*
+ * Some basic random number/hashing functions that should
+ * be okay for initial release
+ *
+ * XXXNJW: Need a more secure method?
+ */
+u_int64_t
+mp_generate_local_key(void)
+{
+       u_int64_t key = arc4random();
+       key = key << 32;
+       key += arc4random();
+       return key;
+}
+
+/*
+ * Digest is for a 20 byte SHA1, key is the session key created
+ * when the mpcb was created
+ */
+uint32_t
+mp_do_sha_hash(uint8_t *digest, uint8_t *key, uint64_t key_length) {
+
+       SHA1_CTX context;
+
+       if ((key == NULL) || (key_length == 0)) {
+              return (0);
+       }
+
+       SHA1Init(&context);
+       SHA1Update(&context, key, key_length);
+       SHA1Final(digest, &context);
+
+       return key_length;
+}
+
+// XXXNJW: turn these into Macros
+/*
+ * Take a digest and return a token. Linux_compat
+ * changes the offset into the digest.
+ */
+uint32_t
+mp_get_token(uint8_t *digest) {
+	if(!linux_compat)
+		return (*((uint32_t *) (digest + 16)));
+	else
+		return (*((uint32_t *) (digest)));
+}
+
+/*
+ * Take a digest and return the idsn. Linux_compat
+ * changes the offset into the digest.
+ */
+
+uint64_t
+mp_new_idsn(uint8_t *digest) {
+	if(!linux_compat)
+		return (*((uint64_t *) (digest)));
+	else
+		return (*((uint64_t *) (digest+12)));
+}
+
+/*
+ * HMAC for used when completing mp_join handshake.
+ * We use the hmac functions implemented in sctp_auth.c
+ */
+uint32_t
+mp_get_hmac(uint8_t *digest, uint64_t local_key, uint64_t remote_key,
+		uint32_t local_rand, uint32_t remote_rand) {
+	/*
+	* Set up the hmac key
+	*/
+	uint8_t key[16];
+	uint32_t keylen = sizeof(local_key) + sizeof(remote_key);
+
+	bcopy(&local_key, key, sizeof(local_key));
+	bcopy(&remote_key, key + 8, sizeof(remote_key));
+
+	/*
+	* Set up the hmac msg
+	*/
+	uint64_t hmac_msg;
+	hmac_msg = (uint64_t)local_rand << 32;
+	hmac_msg |= remote_rand;
+
+	/*
+	 * Do the hashing. 0x0001 is the type for sha1
+	 */
+	uint32_t hmac_len = sctp_hmac(0x0001, key, keylen,
+	    (uint8_t *) &hmac_msg, sizeof(hmac_msg), digest);
+
+	return(hmac_len);
+}
+
+/*
+ * Debugging function for printing a sequence of bytes
+ */
+void
+btohex(char *buf, uint32_t buf_len, uint8_t *bytes, int32_t bytes_len, int32_t flags)
+{
+	struct sbuf out;
+	int32_t i;
+
+	i = bytes_len - 1;
+	sbuf_new(&out, buf, buf_len, 0);
+
+	while (i >= 0) {
+		if (flags & BTOHEX_MSBRTOL)
+			sbuf_printf(&out, "%0x", *(bytes + bytes_len - i - 1));
+		else
+			sbuf_printf(&out, "%0x", *(bytes + i));
+		i--;
+	}
+
+	sbuf_finish(&out);
+}
+
+/*
+ * Return the common rcv window. The window is updated when soreceive is called
+ * and is attached to the subsequent outgoing DACK that signifies that data
+ * has been read by the application.
+ */
+uint32_t
+mp_get_recwin(struct mpcb *mp) {
+	mp_update_recwin(mp);
+	return mp->ds_rcv_wnd;
+}
+
+static void
+mp_update_recwin(struct mpcb *mp) {
+	/* would an atomic_set_32 work here? or issues with SMP? */
+	MPCB_LOCK(mp);
+	mp->ds_rcv_wnd = sbspace(&mp->master_socket->so_rcv);
+	MPCB_UNLOCK(mp);
+}
+
+void
+mp_update_sndwin(struct mpcb *mp, uint16_t win) {
+	/* would an atomic_set_32 work here? or issues with SMP? */
+	MPCB_LOCK(mp);
+	mp->ds_snd_wnd = win;
+	MPCB_UNLOCK(mp);
+}
+
+int
+mp_close_subflows() {
+	//XXXNJW: tdb
+	return (0);
+}
+
+int
+mp_close_subflow(struct tcpcb *tp) {
+	//XXXNJW: tdb
+	return (0);
+}
+
+/* drop a subflow tcpcb from the list of subflows on this mp connection.
+ * XXXNJW: the locking situation here? */
+void
+mp_drop_subflow_tp(struct mpcb *mp, struct tcpcb *tp) {
+	mp_debug(MPSESSION, 1, 0, "%s: dropping tp %p from mp->tp_list\n",
+	    __func__, tp);
+	MPCB_LOCK(mp);
+	SLIST_REMOVE(&mp->tp_list, tp, tcpcb, next_subflow);
+	MPCB_UNLOCK(mp);
+}
+
+/*
+ * XXXNJW: To change. Currently used to call tcp_output on subflows that are
+ * 'waiting' for data (they didn't get an maps from the send buffer on the last
+ * call through).
+ */
+void
+mp_datascheduler_task_handler(void *context, int pending)
+{
+	struct mpcb *mp;
+	struct tcpcb *sf_tp;
+
+	mp = (struct mpcb *)context;
+	KASSERT(mp != NULL, ("%s: mp from context was NULL\n", __func__));
+
+	SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+		INP_WLOCK(sf_tp->t_inpcb);
+		if (!(sf_tp->t_inpcb->inp_flags & INP_DROPPED)
+		    && (sf_tp->sf_flags & SFF_DATA_WAIT) && (sf_tp->t_rxtshift == 0)) {
+			tcp_output(sf_tp);
+			INP_WUNLOCK(sf_tp->t_inpcb);
+			break;
+		}
+		INP_WUNLOCK(sf_tp->t_inpcb);
+	}
+}
+
+void
+mp_trigger_rexmit(struct mpcb *mp) {
+	taskqueue_enqueue(taskqueue_swi, &mp->rexmit_task);
+}
+
+/*
+ * called when data-level ACK is outstanding. Queue up the maps to be rexmitted
+ * in a new list and schedule the rexmit task. The task handler will rexmit the
+ * maps on the first subflow it finds that isn't in subflow-level rexmit.
+ */
+void
+mp_queue_data_rexmit_unlocked(struct tcpcb *tp) {
+
+	struct mpcb *mp = tp->t_mpcb;
+
+	mp_debug(DSMAP, 2, 0, "%s: ds_snd_una: %u \n", __func__,
+	    (uint32_t) mp->ds_snd_una);
+
+	MPCB_LOCK(mp);
+
+	/* XXXNJW: to keep things simple, if we already have maps to retransmit,
+	 * then continue trying with those rather than adding new ones
+	 *
+	 * if we have maps that have been sent, start above ds_snd_una and have
+	 * not been acked at the subflow level, then we should try to retransmit.
+	 * place these maps into mp_rxmitmaps. When tcp_output is called next,
+	 * the to-retransmit maps will be returned.
+	 */
+	if (TAILQ_EMPTY(&mp->mp_rxtmitmaps)) {
+		struct ds_map *sent_map;
+		// modified to look for rexmits only for tp that
+		// called the function (from tcp_timer)
+		// won't attempt to re-enqueue a segment that was a retransmit of
+		// another segment
+		TAILQ_FOREACH(sent_map, &tp->t_txdsmaps, sf_ds_map_next) {
+			if ((sent_map->ds_map_start >= tp->t_mpcb->ds_snd_una)
+				&& ((sent_map->flags & MAPF_IS_ACKED) == 0)
+				&& ((sent_map->flags & MAPF_IS_REXMIT) == 0)) {
+				mp_debug(DSMAP, 2, 0,"%s: inserting map %p starting at %u "
+					"for rexmit\n", __func__, sent_map,
+					(uint32_t)sent_map->ds_map_start);
+
+				// txdsmaps is from inserted at head, so higher ds
+				// values are near the start of the list. want rexmit
+				// to occur from earliest (closest to ds_una) so by
+				// inserting at head, we order from lowest to highest
+                TAILQ_INSERT_HEAD(&mp->mp_rxtmitmaps, sent_map, rxmit_map_next);
+			}
+		}
+	}
+
+	/* XXXNJW count the number of times this function is called (debugging)*/
+	mp->drexmit_count++;
+
+	MPCB_UNLOCK(mp);
+	taskqueue_enqueue(taskqueue_swi, &mp->rexmit_task);
+}
+
+/*
+ * Find the first subflow that isn't in subflow-level rexmit and do data-level
+ * rexmit on this flow (just call tcp_output, the ds_map code worries about
+ * XXXNJW: or perhaps whichever subflow has cwnd > 1MSS?
+ */
+void
+mp_rexmit_task_handler(void *context, int pending)
+{
+	struct mpcb *mp;
+	struct tcpcb *sf_tp;
+
+	mp = (struct mpcb *)context;
+	KASSERT(mp != NULL, ("%s: mp from context was NULL\n", __func__));
+
+	// XXXNJW add checks that tp exists
+	SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+		INP_WLOCK(sf_tp->t_inpcb);
+		if (!(sf_tp->t_inpcb->inp_flags & INP_DROPPED)
+		    && sf_tp->t_rxtshift == 0
+		    && sf_tp->t_state == TCPS_ESTABLISHED) {
+			tcp_output(sf_tp);
+			INP_WUNLOCK(sf_tp->t_inpcb);
+			break;
+		}
+		INP_WUNLOCK(sf_tp->t_inpcb);
+	}
+
+	if (sf_tp == NULL) {
+		mp_debug(MPSESSION, 1, 0, "%s: all subflows in rexmit\n", __func__);
+
+//		MPCB_LOCK(mp);
+//		struct ds_map *map;
+//		TAILQ_FOREACH(map, &mp->mp_rxtmitmaps, mp_ds_map_next) {
+//			TAILQ_REMOVE(mp->mp_rxtmitmaps, map, rxmit_map_next);
+//		}
+//		MPCB_UNLOCK(mp);
+	}
+}
+
+/*
+ * Allocate PCBs to listen for incoming MP_JOINs. This is called when we
+ * advertise an address using ADD_ADDR.
+ */
+void mp_sf_alloc_task_handler(void *context, int pending) {
+        struct mpcb *mp;
+        struct socket *so;
+        struct inpcb *sf_inp;
+        struct tcpcb *sf_tp;
+        void *laddr;
+        int error;
+
+        mp = (struct mpcb *)context;
+        KASSERT(mp != NULL, ("%s: mp from context was NULL\n", __func__));
+
+        /* Only one subflow - no further PCBs to alloc */
+        if (mp->mp_conn_address_count == 1)
+                return;
+
+        so = mp->master_socket;
+
+        int i;
+        for (i = 1; i < mp->mp_conn_address_count; i++) {
+
+                /* Allocate an inp for the subflow */
+                INP_INFO_WLOCK(&V_tcbinfo);
+                sf_inp = in_pcballoc_subflow(so, &V_tcbinfo);
+                INP_INFO_WUNLOCK(&V_tcbinfo);
+
+                if(!sf_inp) {
+                        goto out;
+                }
+                switch (mp_usable_addresses[i].ss_family) {
+                        case AF_INET:
+                                laddr = &((struct sockaddr_in *)
+                                    &mp_usable_addresses[i])->sin_addr.s_addr;
+                                bcopy(laddr, &sf_inp->inp_laddr.s_addr, 4);
+                                break;
+                        case AF_INET6:
+                                laddr = &((struct sockaddr_in6 *)
+                                    &mp_usable_addresses[i])->sin6_addr.__u6_addr;
+                                bcopy(laddr, &sf_inp->in6p_laddr, 16);
+                                break;
+                }
+
+                /* Using same local and foreign ports as master subflow */
+                sf_inp->inp_lport = mp->master_inpcb->inp_lport;
+                sf_inp->inp_fport = mp->master_inpcb->inp_fport;
+
+                /* Foreign address is that of the master subflow */
+                sf_inp->inp_faddr.s_addr = mp->master_inpcb->inp_faddr.s_addr;
+
+                /* debug output for addresses */
+                char buf[128];
+                inet_ntop(AF_INET, &sf_inp->inp_laddr, buf, sizeof(buf));
+                mp_debug(MPSESSION, 2, 0, "%s: creating inp for %s port %d to ",
+                    __func__, buf, ntohs(sf_inp->inp_lport));
+                inet_ntop(AF_INET, &sf_inp->inp_faddr, buf, sizeof(buf));
+                mp_debug(MPSESSION, 2, 0, "%s port %d\n", buf,
+                    ntohs(sf_inp->inp_fport));
+
+                error = tcp_subflow_attach(so, sf_inp, mp);
+                if (error) {
+                        goto free;
+                }
+
+                INP_HASH_WLOCK(&V_tcbinfo);
+                in_pcbinshash(sf_inp);
+                INP_HASH_WUNLOCK(&V_tcbinfo);
+
+                sf_tp = intotcpcb(sf_inp);
+                sf_tp->t_state = TCPS_LISTEN;
+
+                /* Increase subflow count - this subflow will require a
+                 * correct shutdown, now that it is alloc'd */
+                atomic_add_int(&sf_tp->t_mpcb->subflow_cnt,1);
+                mp_debug(MPSESSION, 4, 0, "%s:%d inc sf count, tp %p\n",
+                    __func__, __LINE__, sf_tp);
+
+                INP_WUNLOCK(sf_inp);
+                break;
+        }
+
+        goto out;
+
+free:
+        in_pcbfree(sf_inp);
+out:
+        return;
+}
+
+/*
+ * Pass in mp control block in context
+ * pending == not sure, read the man page
+ *
+ * -tcp_subflow_attach(so,mp)
+ * 	 -> inpcb_alloc_subflow
+ * 	 -> tcp_newtcpcb
+ * - create sockaddr
+ * - tcp_do_subflow_connect(struct tcpcb *tp, struct sockaddr *nam,
+ *   struct thread *td)
+ */
+
+void mp_join_task_handler(void *context, int pending) {
+	struct inpcb *sf_inp;
+	struct mpcb *mp;
+	struct socket *so;
+	struct tcpcb *tp;
+	struct sockaddr dst_nam;
+	void *laddr;
+	void *faddr;
+	int ret, error;
+
+	mp = (struct mpcb *)context;
+	KASSERT(mp != NULL, ("%s: mp from context was NULL\n", __func__));
+
+	/*
+	 * MAX_SUBFLOWS is not always the same as the
+	 * number of available addresses
+	 */
+	if(!mp->mp_advjoin_mask || mp->subflow_cnt == MAX_SUBFLOWS)
+		return;
+
+	so = mp->master_inpcb->inp_socket;
+
+	/*
+	 * Find the next address to send a JOIN for, then
+	 * assign this to addr and use when connecting the new
+	 * subflow
+	 */
+	int i;
+	for (i = 0; i < mp->mp_added_address_count; i++) {
+		/* continue if this index has sent join already */
+		if (!(mp->mp_advjoin_mask & (1 << i)))
+			continue;
+
+		/* Allocate an inp for the subflow */
+		INP_INFO_WLOCK(&V_tcbinfo);
+		sf_inp = in_pcballoc_subflow(so, &V_tcbinfo);
+		INP_INFO_WUNLOCK(&V_tcbinfo);
+
+		if(!sf_inp)
+			goto out;
+
+		mp_debug(MPSESSION, 3, 0, "%s: added address count %d ", __func__,
+		    mp->mp_added_address_count);
+		mp_debug(MPSESSION, 3, 0, "address count %d\n",
+		    mp->mp_conn_address_count);
+
+		/* if more than one available address, start MP_JOINs from the
+		 * first added address.
+		 * XXXNJW: Temporary until the path manager is implemented
+		 */
+		int j = 0;
+		switch (mp_usable_addresses[j].ss_family) {
+			case AF_INET:
+				laddr = &((struct sockaddr_in *)
+					&mp_usable_addresses[j])->sin_addr.s_addr;
+				bcopy(laddr, &sf_inp->inp_laddr, 4);
+				break;
+			case AF_INET6:
+				laddr = &((struct sockaddr_in6 *)
+					&mp_usable_addresses[j])->sin6_addr.__u6_addr;
+				bcopy(laddr, &sf_inp->in6p_laddr, 16);
+				break;
+		}
+
+		if(!mp_is_if_up((struct sockaddr *) &mp_usable_addresses[j])) {
+			mp_debug(MPSESSION, 1, 0, "%s: usable address is down\n", __func__);
+			continue;
+		}
+
+		/* Use the same local port as the master tp */
+		sf_inp->inp_lport = mp->master_inpcb->inp_lport;
+
+		/* create a tp for the subflow inp */
+		ret = tcp_subflow_attach(so, sf_inp, mp);
+
+		if(mp->master_inpcb->inp_vflag & INP_IPV4) {
+			faddr = &((struct sockaddr_in *)
+				&mp->mp_added_addresses[i])->sin_addr.s_addr;
+			bcopy(faddr, &(((struct sockaddr_in *) &dst_nam)->sin_addr.s_addr),
+				sizeof(struct in_addr));
+			((struct sockaddr_in *) &dst_nam)->sin_port
+				= mp->master_inpcb->inp_fport;
+			dst_nam.sa_len = sizeof(struct sockaddr_in);
+			dst_nam.sa_family = AF_INET;
+		} else if (mp->master_inpcb->inp_vflag & INP_IPV6) {
+			panic("ipv6 not supported yet\n");
+		}
+
+		/* ret > 1 if some kind of error */
+		if (ret) {
+			goto free;
+		}
+
+		tp = intotcpcb(sf_inp);
+		tp->t_inpcb = sf_inp;
+
+		/* debug output for addresses */
+		char buf[128];
+		inet_ntop(AF_INET, &sf_inp->inp_laddr, buf, sizeof(buf));
+		mp_debug(MPSESSION, 4, 0, "%s: Connecting to %s port %d to ",
+			__func__, buf, ntohs(sf_inp->inp_lport));
+		inet_ntop(AF_INET, &(((struct sockaddr_in *) &dst_nam)->sin_addr),
+			buf, sizeof(buf));
+		mp_debug(MPSESSION, 4, 0, "%s port %d\n", buf,
+			ntohs(((struct sockaddr_in *) &dst_nam)->sin_port));
+
+		mp_debug(MPSESSION, 1, 0, "%s: Connecting to %s, tp %p inp %p\n",
+			__func__, buf, tp, sf_inp);
+
+		/* Start connection and send the SYN */
+		/*
+		 * XXXNJW: passing the wrong cred here (swi cred rather than master
+		 * socket cred) Should be passing something like
+		 * 'mp->master_socket->so_cred;'
+		 */
+		error = (*so->so_proto->pr_usrreqs->pru_connect)
+			(so, &dst_nam, curthread);
+		if (error)
+			mp_debug(MPSESSION, 4, 0, "%s: pru_connect error %d\n",
+				__func__, error);
+		else {
+			mp_debug(MPSESSION, 4, 0, "%s:%d inc sf count, currently %d\n",
+				__func__, __LINE__, tp->t_mpcb->subflow_cnt);
+			atomic_add_int(&tp->t_mpcb->subflow_cnt,1);
+		}
+
+		mp->mp_advjoin_mask &= ~(1 << i);
+
+	}
+
+	goto out;
+
+free:
+	in_pcbfree(sf_inp);
+out:
+	return;
+}
+
+/*
+ * Move ds_snd_una forward and schedule drop of bytes acked. if ack'ing
+ * past snd_max, then this is an ACK of a DFIN, so we can begin to close
+ * all the subflows, and the connection.
+ *
+ * If the send window is partially ACKd, then we reset the data-level RTO
+ * timer. If the window is fully ACKd, the timer is stopped.
+ *
+ */
+void
+mp_data_ack(struct mpcb *mp, uint64_t data_ack_num) {
+
+	MPCB_LOCK(mp);
+
+	mp_debug(MPSESSION, 4, 0, "processing DACK %ju (%u), ds-una is %ju\n",
+			data_ack_num, (uint32_t)data_ack_num, mp->ds_snd_una);
+
+	if (data_ack_num > mp->ds_snd_una) {
+		/* Adjust accounting on send buffer. sb_actual is adjusted
+		 * when a 'ds-map' worth of data is acknowledged. */
+		atomic_subtract_acq_int(&mp->master_socket->so_snd.sb_cc,
+		    data_ack_num - mp->ds_snd_una);
+		mp->ds_snd_una = data_ack_num;
+	} else if (data_ack_num > mp->ds_snd_max
+	      && ((mp->mp_state == MPS_M_FIN_WAIT_1)
+	      || (mp->mp_state == MPS_M_LAST_ACK))) {
+		// issue FINs on all the subflows
+	} else if (DSEQ_LEQ(data_ack_num,mp->ds_snd_una)) {
+		/*
+		 * These could be out-of-order DACKs. seems to happen frequently
+		 * when sending from multiple subflows.
+		 */
+	}
+
+	/* If in the process of closing a socket, then we do not want to attempt
+	 * to drop any data from the buffer (it has been flushed at this point) */
+	if ((mp->master_socket->so_state & SS_ISDISCONNECTING) ||
+			(mp->master_socket->so_snd.sb_state & SBS_CANTSENDMORE)) {
+		mp_debug(MPSESSION, 1, 0,
+		    "%s: socket is flushed, updated mp accounting only\n", __func__);
+		goto no_sb_drop;
+	}
+
+	/*
+	 * In theory it would be nice to only call this inside the above if-block
+	 * when a DACK bumps ds_snd_una. Doing so unfortunately leads to
+	 * reproducible connection stalls, and the current hypothesis for why is
+	 * below:
+	 *
+	 * In the multi-subflow scenario a DACK can come in on any subflow at any
+	 * time and some ds_maps may not be able to be freed at the time ds_snd_una
+	 * is bumped due to them not being marked as ACKED by their subflow yet.
+	 * We may then get an old DACK on a subflow which we need to use as the
+	 * trigger to go back and remove maps which couldn't be deleted previously.
+	 */
+	mp_deferred_sbdrop(mp);
+
+no_sb_drop:
+	MPCB_UNLOCK(mp);
+}
+
+void
+mp_init_established(struct tcpcb *tp) {
+
+	struct mpcb *mp = tp->t_mpcb;
+	/* Enabled multipath features */
+	tp->mp_active = 1;
+
+	mp_debug(MPSESSION, 1, 0, "%s: new mp connection for tp: %p: \n",
+	    __func__, tp);
+	mp_debug(MPSESSION, 1, 0, "%s: subflow count: %d\n", __func__,
+	    mp->subflow_cnt);
+
+	/* we know the other end is mp enabled */
+	if (IS_MASTER_TP(tp)) {
+		mp->mp_state = MPS_ESTABLISHED;
+		tp->infinite_map = 0;
+		mp->ds_map_max = mp->ds_snd_una =
+			mp->ds_snd_max =mp->ds_map_min =
+			mp->ds_idsn + 1;
+		mp->ds_rcv_nxt = mp->ds_idsr + 1;
+
+		/*
+		 * Add the master address as a usable address, we may need it as a
+		 * source address if the remote host advertises addresses to us and
+		 * we need to send an MP_JOIN
+		 */
+		void *saddr = &((struct sockaddr_in *)
+		    &mp_usable_addresses[0])->sin_addr.s_addr;
+		bcopy(&mp->master_inpcb->inp_laddr, saddr, sizeof(struct in_addr));
+		mp_usable_addresses[0].ss_family = AF_INET;
+		mp_usable_addresses[0].ss_len = sizeof(struct sockaddr_in);
+
+		/*
+		 * Don't want to advertise the 'primary' address so mask out now
+		 */
+		tp->t_mpcb->mp_advaddr_mask &= ~1;
+
+		mp_debug(MPSESSION, 1, 0, "%s: advadd %u, address count %d \n",
+			__func__, tp->t_mpcb->mp_advaddr_mask, mp->mp_conn_address_count);
+
+		mp_debug(MPSESSION, 1, 0, "%s: master tp %p transitioning to "
+		    "MPS_ESTABLISHED\n", __func__, tp);
+
+		mp_debug(MPSESSION, 1, 0, "%s: idsn - %ju\n",
+		    __func__, (uintmax_t) tp->t_mpcb->ds_idsn);
+
+		mp_debug(MPSESSION, 1, 0, "%s: local token: %u, remote token: %u\n",
+			__func__, (uint32_t) tp->t_mpcb->local_token,
+			(uint32_t) tp->t_mpcb->remote_token);
+
+		mp_debug(MPSESSION, 1, 0, "%s: local key: %ju, remote key: %ju\n",
+			__func__, (uintmax_t) tp->t_mpcb->local_key,
+			(uintmax_t) tp->t_mpcb->remote_key);
+
+		mp_debug(MPSESSION, 5, 0, "%s: ds_rcv_nxt: %u\n", __func__,
+			(uint32_t) tp->t_mpcb->ds_rcv_nxt);
+
+		mp_debug(MPSESSION, 5, 0, "%s: ds_snd_una: %u\n", __func__,
+					(uint32_t) tp->t_mpcb->ds_snd_una);
+
+	}
+
+}
+
+/*
+ * Remove and free maps that have been duplicated (due to re-transmission) and
+ * have been acked at the subflow level. The map is identified as being a
+ * duplicate as soon as the first map of the same
+ */
+static void inline
+mp_drop_dup_maps(struct mpcb *mp) {
+
+	struct ds_map *map, *next_map;
+
+	map = TAILQ_FIRST(&mp->mp_ds_sndmaps);
+	while (map != NULL) {
+		next_map = TAILQ_NEXT(map, mp_ds_map_next);
+		if((map->flags & (MAPF_IS_ACKED)) &&
+				(map->flags & (MAPF_IS_DUP))) {
+			/* Only need to check ACKED/DUP as a map can only be
+			 * marked as MAPF_IS_DUP if another identical map has been ACKED
+			 * at subflow level and is below ds_snd_una. remove it from the
+			 * snd_maps list and dealloc the map. The sent bytes will be
+			 * dropped when we drop the ds_map that was acked first.
+			 *
+			 * XXXNJW: Will need to wait until the next D-ACK to finally drop
+			 * the acked bytes from sendbuffer. Would be good to restart the
+			 * process of inserting maps into 'maps to free' after removing
+			 * the duplicate.
+			 */
+			mp_debug(DSMAP, 5, 0, "%s: mark map dsn: %u as dup and drop %p\n",
+			    __func__, (uint32_t)map->ds_map_start, map);
+			TAILQ_REMOVE(&mp->mp_ds_sndmaps, map, mp_ds_map_next);
+			free(map, M_DSSMAP);
+		}
+		map = next_map;
+	}
+}
+
+/*
+ * See what ds_maps can be dropped.
+ */
+void
+mp_deferred_sbdrop(struct mpcb *mp) {
+	struct ds_map *map, *next_map;
+	struct mbuf *cannotfreembptr;
+	int ndrop = 0;
+	uint64_t ds_high_drop, ds_map_end;
+
+	/* Keep a list of maps that should be freed only if ndrop is > 0 */
+	struct dsmapq_head maps_to_free;
+	/* Keep a list of maps that are removed from ds_snd_maps if they are a
+	 * duplicate of a map that has been acked, and ndrop > 0 */
+	struct dsmapq_head dup_maps;
+
+	if (!mp->master_tcpcb->infinite_map)
+		MPCB_LOCK_ASSERT(mp); /* Called from mp_data_ack() */
+
+	mp_drop_dup_maps(mp);
+
+	TAILQ_INIT(&maps_to_free);
+	TAILQ_INIT(&dup_maps);
+	cannotfreembptr = NULL;
+	ds_high_drop = 0;
+
+	TAILQ_FOREACH(map, &mp->mp_ds_sndmaps, mp_ds_map_next) {
+		ds_map_end = map->ds_map_start + map->ds_map_len;
+
+		mp_debug(DSMAP, 5, 0, "%s: check map %p, ds_map_start: %ju, ds_map_end %ju, ds_snd_una %ju, "
+				"ds_high_drop: %ju, mbuf_start: %p, mbuf_offset: %u, mbuf_len: %d\n",
+				__func__, map, (uintmax_t) map->ds_map_start, (uintmax_t) ds_map_end,
+				(uintmax_t) mp->ds_snd_una, (uintmax_t) ds_high_drop, map->mbuf_start,
+				map->mbuf_offset, map->mbuf_start->m_len);
+
+		mp_debug(DSMAP, 5, 0, "MAPF_IS_ACKED: %u \n",
+		    (map->flags & MAPF_IS_ACKED));
+
+		/*
+		 * Can we drop this map?
+		 * - Has it been cumulatively ACKED and not a duplicate
+		 * - Does the sequence space start and end before ds_snd_una
+		 */
+		if ((map->flags & MAPF_IS_ACKED) && map->ds_map_start < mp->ds_snd_una
+		    && ds_map_end <= mp->ds_snd_una &&
+		    ((map->flags & MAPF_IS_DUP) == 0)) {
+
+			if (ds_high_drop == 0)
+				ndrop = map->ds_map_len;
+			else if (ds_high_drop < ds_map_end)
+				ndrop += ds_map_end - ds_high_drop;
+
+			ds_high_drop = ulmax(ds_map_end, ds_high_drop);
+
+			mp_debug(DSMAP, 5, 0, "%s: ds_high_drop: %ju, ndrop: %d, sb_cc: %d\n",
+			    __func__, (uintmax_t)ds_high_drop, ndrop,
+				mp->master_socket->so_snd.sb_cc);
+
+			/*
+			 * We are re-using the sf_ds_map_next link as it is no longer
+			 * used at the subflow level (the map is removed from the subflow
+			 * map list before it is marked as MAPF_IS_ACKED).
+			 */
+			TAILQ_INSERT_HEAD(&maps_to_free, map, sf_ds_map_next);
+
+		} else if (map->ds_map_start >= mp->ds_snd_una
+		      || map->ds_map_start > ds_high_drop) {
+
+			/* CHECK mbuf_start + map->mbuf_offset against other maps to be freed
+			 * and only allow free if they won't invalidate other mbuf_offset values.
+			 */
+			cannotfreembptr = map->mbuf_start;
+			mp_debug(DSMAP, 5, 0, "%s: reached end of freeable maps at mbuf %p len %d\n\n",
+			    __func__, cannotfreembptr, cannotfreembptr->m_len);
+			/* The list is ordered based on ascending ds_map_start, therefore maps
+			 * including and after this map cannot be freed. OR This map does not
+			 * overlap with any previous maps therefore it is safe to free up to
+			 * but not including this map. */
+			break;
+		} else {
+			/* We have overlap between a completed and uncompleted map that
+			 * is below una or we have a map that overlaps and extends past
+			 * una */
+			mp_debug(DSMAP, 5, 0, "%s: map overlap below una, can't drop anything\n", __func__);
+
+			struct ds_map *acked_map;
+			/* check if this map completely overlaps with a map that is ACKED
+			 */
+			TAILQ_FOREACH(acked_map, &mp->mp_ds_sndmaps, mp_ds_map_next) {
+				/* A duplicate map will have the same start and end ds_num,
+				 * but will not have been ACKED */
+				if ((map->ds_map_start == acked_map->ds_map_start) &&
+				    (map->ds_map_len == acked_map->ds_map_len) &&
+				    (map != acked_map) && (acked_map->flags & MAPF_IS_ACKED)) {
+					    mp_debug(DSMAP, 5, 0, "%s: found dup %p of acked map "
+					    	"%p ds_start %u acked map mbuf start %p\n",
+						    __func__, map, acked_map,
+						    (uint32_t) map->ds_map_start,
+						    acked_map->mbuf_start);
+						map->flags |= MAPF_IS_DUP;
+
+//						/* Might have multiple dups. We do not want to add them
+//						 * to the dup_list twice so need to check the dup_maps
+//						 * list for this map */
+//						TAILQ_FOREACH(dup_map, &dup_maps, mp_dup_map_next) {
+//							if (map == dup_map)
+//								dup_is_in_list = 1;
+//						}
+//
+//						/* Use a new link here - mp_dup_map_next - as the mp_
+//						 * and sf_ links are being used (sf_ds_map_next link
+//						 * is used in the "maps to free" list).
+//						 */
+//						if (!dup_is_in_list)
+//							TAILQ_INSERT_HEAD(&dup_maps, map, mp_dup_map_next);
+				}
+			}
+
+			/* found a duplicate. continue looking for maps to free as there
+			 * may be more maps following the duplicate */
+//			if (found_dup)
+//				continue;
+
+			/* Often in here due to DACKs arriving on a different subflow to
+			 * what the map was sent on. hence the map may not have been acked
+			 * at the subflow level and not marked as "MAPF_IS_ACKED". the map
+			 * will not be freed until this flag has been set */
+
+			ndrop = 0;
+			break;
+		}
+	}
+
+	/* Error as we are dropping more than in the sb */
+	KASSERT(ndrop <= mp->master_socket->so_snd.sb_actual,
+	    ("%s: ndrop %d > sb_actual %d\n" , __func__, ndrop,
+	    mp->master_socket->so_snd.sb_actual));
+
+
+	if (ndrop > 0) {
+		int bytes_from_end;		   // sqn in mbuf_end when the map ends
+		struct mbuf *map_mbuf_end; // The mbuf in which this map ends
+		struct mbuf *last_dropped;
+
+//		/* get rid of dup maps at this time. We know that the acked map will
+//		 * be dropped */
+//		struct ds_map *dup_map;
+//		TAILQ_FOREACH(dup_map, &dup_maps, mp_dup_map_next) {
+//			/* Will check MAPF_IS_DUP in tcp_ackmap. if found in tcp_ackmap,
+//			 * the map will be freed there as the data-level portion has
+//			 * been acked and the data freed from the send buffer */
+//			printf("%s: removing dup map %p from mp_sndmaps, set dup flag\n",
+//			    __func__, dup_map);
+//			dup_map->flags |= MAPF_IS_DUP;
+//
+//			/* use the mp_ds_map_next link so that mp_ds_sndmaps is updated
+//			 * correctly. dup_maps is INITd each time we come into deferred_
+//			 * sb_drop so dot not need to remove from the dup list */
+//			TAILQ_REMOVE(&mp->mp_ds_sndmaps, dup_map, mp_ds_map_next);
+//		}
+
+		map = TAILQ_FIRST(&maps_to_free);
+		while (map != NULL) {
+			next_map = TAILQ_NEXT(map, sf_ds_map_next);
+
+			map_mbuf_end = map->mbuf_start;
+			bytes_from_end = map->ds_map_len + map->mbuf_offset;
+
+//			/* this is a small map that ends within the length of the mbuf, and
+//			 * we have another map that might occupy this same mbuf */
+//			if (bytes_from_end < map_mbuf_end->m_len
+//			    && next_map && next_map->mbuf_start == map->mbuf_start) {
+//				printf("%s: bytes_from_end %d, mb_len %d, map_start %u\n",
+//				    __func__, bytes_from_end, map_mbuf_end->m_len,
+//				    (uint32_t) map->ds_map_start);
+//				TAILQ_REMOVE(&mp->mp_ds_sndmaps, map, mp_ds_map_next);
+//				map = next_map;
+//				continue;
+//			}
+
+			while (bytes_from_end > map_mbuf_end->m_len) {
+				bytes_from_end -= map_mbuf_end->m_len;
+				map_mbuf_end = map_mbuf_end->m_next;
+			}
+
+			if (map_mbuf_end == cannotfreembptr) {
+				mp_debug(DSMAP, 4, 0, "%s: snd_dsmap %p TWEAKED - "
+						"bytes_from_end: %d\n", __func__, map, bytes_from_end);
+				mp_debug(DSMAP, 4, 0, "    PRE TWEAK - ndrop: %d, "
+				    "ds_map_start: %ju ds_map_len: %u, mbuf_start: %p, "
+				    "mbuf_offset: %u, mbuf_len: %d ds_high_drop: %ju\n",
+					ndrop, (uintmax_t)map->ds_map_start, map->ds_map_len,
+					map->mbuf_start, map->mbuf_offset, map->mbuf_start->m_len,
+					(uintmax_t)ds_high_drop);
+
+				if(map->mbuf_start != map_mbuf_end) {
+					map->mbuf_start = map_mbuf_end;
+					map->mbuf_offset = 0;
+					map->ds_map_start = map->ds_map_start +
+					    map->ds_map_len - bytes_from_end;
+					map->ds_map_len = bytes_from_end;
+				}
+
+				if (ds_high_drop > map->ds_map_start) {
+					ndrop -= ds_high_drop - map->ds_map_start;
+					KASSERT(ndrop >= 0, ("%s: negative ndrop value - "
+					    "%d\n", __func__, ndrop));
+					ds_high_drop = map->ds_map_start;
+				}
+
+				mp_debug(DSMAP, 5, 0, "    POST TWEAK - ndrop: %d, "
+				    "ds_map_start: %ju ds_map_len: %u, mbuf_start: %p, "
+				    "mbuf_offset: %u, mbuf_len: %d, ds_high_drop: %ju\n\n",
+					ndrop, (uintmax_t)map->ds_map_start, map->ds_map_len,
+					map->mbuf_start, map->mbuf_offset, map->mbuf_start->m_len,
+					(uintmax_t)ds_high_drop);
+
+			} else {
+				/* Map has yet to be removed from the mp snd list, so we do so
+				 * here before freeing the the map from memory, to prevent
+				 * dangling pointers in the mp snd list. The map is no longer
+				 * needed from this point. */
+				TAILQ_REMOVE(&mp->mp_ds_sndmaps, map, mp_ds_map_next);
+				last_dropped = map->mbuf_start;
+				mp_debug(DSMAP, 5, 0, "%s: snd_dsmap %p DELETED. map_len: "
+				    "%d, mbuf_start: %p, sf_seq_start: %u\n",
+				    __func__, map, map->ds_map_len, map->mbuf_start,
+				    map->sf_seq_start);
+				free(map, M_DSSMAP);
+			}
+			map = next_map;
+	     }
+
+		/*
+		 * (1) Make sure we are not dropping more than is in the send buffer
+		 * (2) Make sure that we are not dropping more than has been accounted
+		 *     for. (i.e. dont drop more than una/sb_actual - should not drop
+		 *     below the length of sb_cc
+		 */
+		KASSERT((int)mp->master_socket->so_snd.sb_actual - ndrop >= 0
+				&& mp->master_socket->so_snd.sb_cc <= mp->master_socket->so_snd.sb_actual - ndrop,
+			("%s: SB_DEFERACCT sb_cc/sb_actual accounting error: "
+			"sb_cc %u, sb_actual %u, len %d", __func__, mp->master_socket->so_snd.sb_cc,
+			mp->master_socket->so_snd.sb_actual, ndrop));
+
+	     mp_debug(DSMAP, 4, 0, "%s: Dropping %d bytes from socket "
+	         "buffer\n", __func__, ndrop);
+	 	 SOCKBUF_LOCK(&mp->master_socket->so_snd);
+	     sbdrop_locked(&mp->master_socket->so_snd, ndrop);
+	     mp->ds_map_min += ndrop;
+	     sowwakeup_locked(mp->master_socket);
+	} else if ((mp->ds_snd_una == mp->ds_snd_max)
+	    && (mp->master_socket->so_snd.sb_cc == 0)) {
+		/* We might not not be able to drop segments due to duplicate maps.
+		 * However is we have sent a full window and sb_cc is zero, then
+		 * everything has been acked and we should try to continue sending
+		 * new data. This call sowwakeup on the so_snd */
+//		printf("%s: attempt sowwakeup ds_una %u actual %d\n",
+//		    __func__, (uint32_t) mp->ds_snd_una,
+//		    mp->master_socket->so_snd.sb_actual);
+//		printf("%s: sbspace %ld, tp %p\n", __func__,
+//		    sbspace(&mp->master_socket->so_snd),
+//		    mp->master_tcpcb);
+		sowwakeup(mp->master_socket);
+	}
+
+}
+
+/*
+ * Accesses socket buffer on behalf on a subflow and returns a mapping
+ * into the send buffer than the subflow will transmit from.
+ *
+ * XXXNJW: currently restricted to returning a map of size 1420 (this allows
+ * space for header and options to be added while staying under the MSS)
+ */
+struct ds_map*
+mp_get_map(struct mpcb *mp, unsigned int sf_mss) {
+	struct ds_map *map = NULL;
+	struct socket *so;
+	int map_length;
+
+	MPCB_LOCK(mp);
+	so = mp->master_socket;
+	SOCKBUF_LOCK(&so->so_snd);
+
+	/*
+	 * XXXNJW do we have maps to be rexmitted?
+	 * if yes, find if this map has an existing dup in sndmaps marked as
+	 * MAPF_IS_REXMIT. if this is the case, the map will be a retransmit of
+	 * a retransmit. continue to the next map (not sure what to do with
+	 * retransmits of retransmits at the data-level).
+	 */
+	TAILQ_FOREACH(map, &mp->mp_rxtmitmaps, mp_ds_map_next) {
+		struct ds_map *next_map;
+		int skip_map = 0;
+
+		/*
+		 * Is a dup marked as MAPF_IS_REXMIT? then it is a rexmitted map
+		 * that hasn't been acked. how to handle this situation? the tp is
+		 * important, as we don't want to remap sf_sqns. rexmitted maps may
+		 * end up in this list if enough TCP-level RTOs take place _after_
+		 * it has been previously transmitted (and as a rexmit of another
+		 * segment). These maps can't be re-mapped (within the same sf)
+		 * as it will cause the ds and sf sequence spaces to become out of
+		 * sync.
+		 *
+		 * Note: The function enqueuing segments for rexmit will ignore maps
+		 * that are marked as "MAPF_IS_REXMIT", so these checks are redundant
+		 * for the current behaviour.
+		 */
+		TAILQ_FOREACH(next_map, &mp->mp_ds_sndmaps, mp_ds_map_next) {
+			if ((next_map->ds_map_start == map->ds_map_start)
+			    && (next_map->flags & MAPF_IS_REXMIT)
+			    && next_map != map) {
+				skip_map = 1;
+				break;
+			}
+		}
+
+		if (skip_map) {
+			mp_debug(DSMAP, 2, 0, "%s: found existing rexmit %p\n", __func__,
+			    map);
+			continue;
+		}
+
+		// for now not rexmitting rexmits.... (if the RTOs of two subflows
+		// can't deal with it, in the current implementation that would be
+		// a stalled connection.
+		if (map->flags & MAPF_IS_REXMIT)
+			continue;
+
+		/* The map is okay to rexmit */
+		break;
+	}
+
+	if(map) {
+		// set a flag that will cause mp_get_map to return the map nearest
+		// ds_snd_una so that it can be retransmitted.
+		mp->doing_rxmit = 1;
+
+		struct ds_map *rxmit_map;
+		rxmit_map = malloc(sizeof(struct ds_map), M_DSSMAP, M_NOWAIT|M_ZERO);
+		/* copy the data-level info to the new map
+		 * subflow details are added on return to tcp_output */
+		rxmit_map->mbuf_start = map->mbuf_start;
+		rxmit_map->mbuf_offset = map->mbuf_offset;
+		rxmit_map->ds_map_start = map->ds_map_start;
+		rxmit_map->ds_map_len = map->ds_map_len;
+		rxmit_map->flags |= MAPF_IS_REXMIT;
+		mp_insert_map(mp, rxmit_map);
+
+		mp_debug(DSMAP, 2, 0, "%s: attempt to rexmit map %p dsn: %u tseq: %u\n",
+			__func__, map, (uint32_t) map->ds_map_start, map->sf_seq_start);
+
+		/*
+		 * remove the map from the "to retransmit" list. If this retransmit
+		 * fails then it may be inserted into the rxtmitmaps list itself.
+		 *
+		 * XXXNJW: Should the rexmit be retransmitted, or again copy the
+		 * original and try a different subflow?
+		 */
+		TAILQ_REMOVE(&mp->mp_rxtmitmaps, map, rxmit_map_next);
+
+		SOCKBUF_UNLOCK(&so->so_snd);
+		MPCB_UNLOCK(mp);
+
+		return(rxmit_map);
+
+	}
+
+	if (mp->doing_rxmit)
+		mp_debug(REASS, 3, 0, "%s: exiting need rexmit\n", __func__);
+
+	mp->doing_rxmit = 0;
+
+	/* If there are bytes in the send buff that could potentially be
+	 * sent
+	 * */
+	if(so->so_snd.sb_cc) {
+		/* XXXNJW: the single map per packet workaround is horrible but works
+		 * well enough for debugging. 1420 is a safe enough size that we know
+		 * the segment wont be split into multiple packets or trigger sendalot
+		 */
+		if (single_packet_maps)
+			map_length = min(SB_NUNMAPPED(&so->so_snd, mp), 1420);
+		else {
+			if (so->so_snd.sb_cc >= so->so_snd.sb_hiwat
+				&& (SB_NUNMAPPED(&so->so_snd, mp) > sf_mss))
+				map_length = SB_NUNMAPPED(&so->so_snd, mp) / mp->subflow_cnt;
+			else
+				map_length = SB_NUNMAPPED(&so->so_snd, mp);
+		}
+
+		mp_debug(DSMAP, 3, 0, "%s - sbcc: %u, sb_hiwat: %u, unmapped:_cc %d, "
+			"subflow_cnt: %d\n",
+		    __func__, so->so_snd.sb_cc, so->so_snd.sb_hiwat,
+		    SB_NUNMAPPED(&so->so_snd, mp), mp->subflow_cnt);
+
+		KASSERT (so->so_snd.sb_actual >= (mp->ds_map_max - mp->ds_map_min),
+			("%s: Negative map length\n", __func__));
+
+		if (map_length > 0) {
+			map = malloc(sizeof(struct ds_map), M_DSSMAP, M_NOWAIT|M_ZERO);
+
+			if (map) {
+				/* XXXNJW: in future at this point want to decide how
+				 * many bytes are sent from the sockbuf rather than simply
+				 * sbchars.
+				 */
+				map->mbuf_start = sbsndptr(&so->so_snd,
+					(mp->ds_map_max - mp->ds_map_min),
+					map_length, &map->mbuf_offset);
+
+				map->ds_map_start = mp->ds_map_max;
+				map->ds_map_len = map_length;
+
+				mp_debug(DSMAP, 4, 0, "%s: map %p, ds_map_start %ju, "
+					"ds_map_end %ju, mbuf_start %p, mb_offset: %u, offset: "
+					"%ju, maplen: %d, sbcc: %u, sb_mb: %p\n",
+				    __func__, map, (uintmax_t)map->ds_map_start,
+				    (uintmax_t)map->ds_map_start+map_length, map->mbuf_start,
+				    map->mbuf_offset, (uintmax_t)(mp->ds_map_max - mp->ds_snd_una),
+					map_length, so->so_snd.sb_cc,so->so_snd.sb_mb);
+				mp->ds_map_max += map_length;
+				mp_insert_map(mp, map);
+			}
+		}
+	}
+
+	SOCKBUF_UNLOCK(&so->so_snd);
+	MPCB_UNLOCK(mp);
+
+	return(map);
+}
+
+void
+mp_insert_map(struct mpcb *mp, struct ds_map *map) {
+
+	// do ordered insert of map into list by ds_start value
+	/*
+	 * Insert the map in data-sequence order by finding an existing
+	 * map whose ds_start value is greater than or equal to the new
+	 * map. Insert the new map before this. If this map is not before
+	 * any existing maps, insert at the tail.
+	 */
+	struct ds_map *next_map;
+	TAILQ_FOREACH(next_map, &mp->mp_ds_sndmaps, mp_ds_map_next) {
+		if (next_map->ds_map_start == map->ds_map_start) {
+			mp_debug(DSMAP, 4, 0, "%s: inserting %p, dup of %p ds: %u\n",
+			    __func__, map, next_map, (uint32_t) map->ds_map_start);
+		}
+
+		if (next_map->ds_map_start >= map->ds_map_start) {
+			TAILQ_INSERT_BEFORE(next_map, map, mp_ds_map_next);
+			mp_debug(DSMAP, 4, 0, "inserted map %p before map %p\n",
+				map, next_map);
+			break;
+		}
+	}
+	if (next_map == NULL) {
+		mp_debug(DSMAP, 4, 0, "inserting map %p at tail of "
+			"mp_ds_sndmaps, is mp_ds_sndmaps empty %d\n",
+			map, TAILQ_EMPTY(&mp->mp_ds_sndmaps));
+		TAILQ_INSERT_TAIL(&mp->mp_ds_sndmaps, map, mp_ds_map_next);
+	}
+
+	/* XXX: Can go under #ifdef INVARIANTS */
+	int total_mapped = 0;
+	uint64_t last_map_end = 0;
+	uint64_t ds_high_drop = 0, ds_map_end = 0;
+	TAILQ_FOREACH(next_map, &mp->mp_ds_sndmaps, mp_ds_map_next) {
+		ds_map_end = next_map->ds_map_start + next_map->ds_map_len;
+
+		/* If this map doesn't progress any futher towards snd_max, then
+		 * we continue past it. */
+		if ((last_map_end > 0) && (ds_map_end == last_map_end))
+			continue;
+
+		if (ds_high_drop == 0)
+			total_mapped = next_map->ds_map_len;
+		else if (ds_high_drop < ds_map_end)
+			total_mapped += ds_map_end - ds_high_drop;
+
+		ds_high_drop = ulmax(ds_map_end, ds_high_drop);
+		last_map_end = ds_map_end;
+	}
+
+	KASSERT(total_mapped == mp->ds_map_max - mp->ds_map_min,
+			("total bytes in ds maps %d not equal to mapped bytes in sockbuf "
+			"(ds_map_max - ds_map_min) %ju - %ju = %ju\n",
+			total_mapped, (uintmax_t)mp->ds_map_max, (uintmax_t)mp->ds_map_min,
+			(uintmax_t)(mp->ds_map_max - mp->ds_map_min)));
+
+}
+
+struct ds_map *
+mp_find_dsmap(struct tcpcb *tp, tcp_seq	seqnum)
+{
+	struct ds_map *map;
+	tcp_seq sf_seq_end;
+	int new_map, rexmit_map;
+	struct socket *so = tp->t_mpcb->master_socket;
+	struct mpcb *mp = tp->t_mpcb;
+
+	new_map = 0;
+	rexmit_map = 0;
+	map = NULL;
+
+	mp_debug(DSMAP, 3, 0, "%s - sbcc: %u, sb_hiwat: %u, unmapped:_cc %d, "
+		"subflow_cnt: %d\n",
+		__func__,
+		so->so_snd.sb_cc, so->so_snd.sb_hiwat,
+		SB_NUNMAPPED(&so->so_snd, mp), mp->subflow_cnt);
+
+
+	/* Match the first map sitting in txdmaps that is marked as "REXMIT" and
+	 * attempt to transmit this first. it may have been inserted previously
+	 * but not sent. The sequence numbers etc will have been already set.
+	 */
+	TAILQ_FOREACH(map, &tp->t_txdsmaps, sf_ds_map_next) {
+		if ((map->flags & MAPF_IS_REXMIT) && !(map->flags & MAPF_IS_SENT))
+			return(map);
+	}
+
+	/* Only look for maps to transmit if there aren't any already awaiting a
+	 * ds-level retransmit, and sf is not in sf-level rexmit already.
+	 */
+	if (!TAILQ_EMPTY(&mp->mp_rxtmitmaps) && (tp->t_rxtshift == 0))
+		rexmit_map = 1;
+	else {
+		/* Performing wrap detection on map lookups based on sequence number.
+		 * If (sf_seq_end = sf_start + length) wraps, sf_seq_end will be less
+		 * than sf_seq_start. We detect this with: seqnum <= sf_seq_end (seqnum
+		 * is in map) && sf_seq_end < map->sf_seq_start
+		 */
+		TAILQ_FOREACH(map, &tp->t_txdsmaps, sf_ds_map_next) {
+
+			/* reached end of the map list, */
+			sf_seq_end =  map->sf_seq_start + map->ds_map_len;
+			if (seqnum == sf_seq_end) {
+				new_map = 1;
+				break;
+			}
+
+			/* match the first map which covers the passed in sequence num.
+			 * includes checks for wrapped maps. */
+			if ((seqnum >= map->sf_seq_start && sf_seq_end > map->sf_seq_start
+				&& seqnum < sf_seq_end) ||
+				(sf_seq_end < map->sf_seq_start && seqnum < map->sf_seq_start
+				&& seqnum < sf_seq_end) ||
+				(sf_seq_end < map->sf_seq_start && seqnum >= map->sf_seq_start
+				&& seqnum <= UINT_MAX)) {
+					mp_debug(DSMAP, 4, 0, "%s  sequence num: %u"
+						"starts at %u, ends %u\n", __func__,
+						seqnum, map->sf_seq_start, sf_seq_end);
+					break;
+			}
+		}
+	}
+
+//	/* Try to force availability of data to send when we have multiple
+//	 * subflows. This causes a map to not be returned on alternate calls to
+//	 * mp_find_dsmap (except in cases where we are servicing an already
+//	 * allocated map (from the code above).
+//	 */
+//	if (tp->t_mpcb->subflow_cnt > 1 && map == NULL
+//	    && !(tp->sf_flags & SFF_DATA_WAIT) && !rexmit_map) {
+//		tp->sf_flags |= SFF_DATA_WAIT;
+//		return NULL;
+//	}
+
+	if (map == NULL || new_map || rexmit_map) {
+		if ((map == NULL) && (rexmit_map == 0))
+			KASSERT(TAILQ_EMPTY(&tp->t_txdsmaps),
+			    ("%s: %u below sf_seq_start of oldest una map",
+			    __func__, seqnum));
+
+		map = mp_get_map(tp->t_mpcb, tp->t_maxseg);
+		if (map) {
+			map->sf_seq_start = seqnum;
+			map->sf_tp = tp;
+			TAILQ_INSERT_HEAD(&tp->t_txdsmaps, map, sf_ds_map_next);
+
+			/* If this sf is retransmitting a data-segment, don't need to
+			 * change the "wait" status */
+			if ((tp->sf_flags & SFF_DATA_WAIT) && !rexmit_map) {
+				tp->sf_flags &= ~SFF_DATA_WAIT;
+
+				atomic_subtract_acq_int(&tp->t_mpcb->data_wait_count, 1);
+
+				KASSERT(tp->t_mpcb->data_wait_count >= 0,
+				    ("%s data wait count < 0\n",__func__));
+				mp_debug(DSMAP, 5, 0, "tp %p got data after waiting, length: "
+				    "%d\n", tp, map->ds_map_len);
+			}
+			/* Have at least one subflow that had to wait to send data,
+			 * enqueue to data task so that tcp_output can be called. */
+			if (atomic_load_acq_int(&tp->t_mpcb->data_wait_count) > 0) {
+				taskqueue_enqueue(taskqueue_swi, &tp->t_mpcb->data_task);
+			}
+		} else {
+			/* No map was returned. should set SFF_DATA_WAIT to ensure that
+			 * we try to allocate a map to this subflow in the next call to
+			 * mp_find_dsmap
+			 */
+			if (!(tp->sf_flags & SFF_DATA_WAIT)) {
+				tp->sf_flags |= SFF_DATA_WAIT;
+				atomic_add_acq_int(&tp->t_mpcb->data_wait_count, 1);
+			}
+		}
+	}
+
+	return (map);
+}
+
+
+
+/*
+ * When a zero window is opened up, we should let all the subflows know.
+ * Can do this by triggering an ACK (the new window will be placed in the
+ * header
+ */
+void
+mp_update_subflow_windows(struct tcpcb *tp) {
+	struct mpcb *mp = tp->t_mpcb;
+	struct tcpcb *sf_tp;
+	int	sf_count;
+
+	INP_INFO_WLOCK(&V_tcbinfo);
+	sf_count = mp->subflow_cnt - 1;
+
+	/* -1 since we skip the calling tp */
+	struct inpcb *subflow_inps[sf_count];
+
+	int i = 0;
+	SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+		if (sf_tp == tp)
+			continue;
+		INP_RLOCK(sf_tp->t_inpcb);
+		subflow_inps[i] = sf_tp->t_inpcb;
+		in_pcbref(sf_tp->t_inpcb);
+		INP_RUNLOCK(sf_tp->t_inpcb);
+		i++;
+	}
+	INP_INFO_WUNLOCK(&V_tcbinfo);
+
+
+	/* Only master subflow exists */
+	if (i == 0)
+		return;
+
+	for (i = 0; i < sf_count; i++) {
+		struct inpcb *sf_inp = subflow_inps[i];
+		INP_WLOCK(sf_inp);
+		if ((sf_inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED))) {
+			in_pcbrele(sf_inp);
+			INP_WUNLOCK(sf_inp);
+			continue;
+		}
+
+		sf_tp = intotcpcb(sf_inp);
+		sf_tp->t_flags |= TF_ACKNOW;
+		tcp_output(sf_tp);
+		if (in_pcbrele(sf_inp))
+			continue;
+		INP_WUNLOCK(sf_inp);
+	}
+
+	return;
+}
+
+void
+mp_subflow_is_disconnected(struct tcpcb *tp) {
+
+	struct mpcb *mp = tp->t_mpcb;
+	struct tcpcb *sf_tp;
+	int all_closed = 1;
+
+	/* Do not want to call soisdisconnected if master tp is still
+	 * progressing through connection teardown. */
+	if (tp->t_state < TCPS_FIN_WAIT_2)
+		return;
+
+	INP_WLOCK_ASSERT(tp->t_inpcb);
+
+	SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+		if (sf_tp == tp)
+			continue;
+
+		mp_debug(MPSESSION, 1, 0, "%s: tp state: %d master: %d\n", __func__,
+			sf_tp->t_state, IS_MASTER_TP(sf_tp) ? 1 : 0);
+
+		/*
+		 * The calling thread holds a write lock on the tp
+		 * that is just transitioning to FIN_WAIT_2. When this function
+		 * is run from a different context it will not race with this
+		 * thread when checking its state.
+		 */
+		INP_RLOCK(sf_tp->t_inpcb);
+
+		/* Do not call soisdisconnected while at least one subflow is
+		 * still in connection teardown */
+		if (sf_tp->t_state < TCPS_FIN_WAIT_2)
+			all_closed = 0;
+		INP_RUNLOCK(sf_tp->t_inpcb);
+		if (!all_closed)
+			break;
+	}
+
+	if(all_closed) {
+		mp_debug(MPSESSION, 1, 0, "%s: all closed\n", __func__);
+		soisdisconnected(mp->master_socket);
+	}
+
+
+}
+
+/*
+ * Used to determine when we can set the socket as "cantrcvmore". Needed
+ * as subflows will shut-down asynchronously at times.
+ * XXXNJW: To be overhauled when DFIN support is added in.
+ */
+void
+mp_set_cantrcvmore(struct tcpcb *tp) {
+	struct mpcb *mp = tp->t_mpcb;
+	struct socket *so = mp->master_socket;
+	struct tcpcb *sf_tp;
+	int all_finned = 1;
+
+	INP_WLOCK_ASSERT(tp->t_inpcb);
+
+	SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+		if (sf_tp == tp)
+			continue;
+
+		if (sf_tp->t_state == TCPS_ESTABLISHED ||
+			((sf_tp->t_state > TCPS_ESTABLISHED) &&
+			(sf_tp->t_state != TCPS_CLOSE_WAIT) &&
+		    (sf_tp->t_state != TCPS_TIME_WAIT) &&
+		    (sf_tp->t_state != TCPS_CLOSING))) {
+			all_finned = 0;
+			break;
+		}
+	}
+
+	if (all_finned)
+		if ((so->so_rcv.sb_state & SBS_CANTRCVMORE) == 0)
+			socantrcvmore(so);
+}
+
+/* If we are attempting to use an interface, need to make sure that it is up.
+ * this is more important for things like sending ADD_ADDRs on interfaces that
+ * aren't up (this can happen if the sysctl is configured to use an address,
+ * and that address happens to be down/non existent */
+int
+mp_is_if_up(struct sockaddr *l_addr) {
+	struct ifaddr *ifa = NULL;
+
+	ifa = ifa_ifwithaddr(l_addr);
+	if (!ifa)
+		return 0;
+
+	return (ifa->ifa_ifp->if_flags & IFF_UP);
+}
+
+/* If the added address is being used in the master_tp (i.e. is default route)
+ * we do not want to be advertising this (it will eventually try to bind the
+ * same address and port as the master tp, causing problems) */
+int
+mp_is_addr_default(struct sockaddr_in *l_addr, struct mpcb *mp) {
+	void *addr;
+	char inet_buf[64];
+
+	addr = &l_addr->sin_addr;
+	inet_ntop(AF_INET, addr, inet_buf, mp_usable_addresses[0].ss_len);
+	mp_debug(MPSESSION, 1, 0, "%s: Comparing added address %s ", __func__,
+	    inet_buf);
+
+	addr = &((struct sockaddr_in *) &mp_usable_addresses[0])->sin_addr;
+	inet_ntop(AF_INET, addr, inet_buf, mp_usable_addresses[0].ss_len);
+	mp_debug(MPSESSION, 1, 0, "with default %s\n", inet_buf);
+
+	/* is the passed-in interface the same as the default interface  */
+	if (l_addr->sin_addr.s_addr == mp->master_inpcb->inp_laddr.s_addr)  {
+		mp_debug(MPSESSION, 1, 0, "%s: mp_addresses entry same as master_tp "
+		    "addr\n", __func__);
+		return 1;
+	}
+
+	mp_debug(MPSESSION, 1, 0, "%s: mp_addresses entry not same as master_tp "
+	    "addr\n", __func__);
+	return 0;
+}
+
+void
+mp_update_available_addresses(struct mpcb *mp) {
+	struct mp_add address;
+	int new_address_count = mp->mp_conn_address_count;
+	int i;
+
+	address.length = address.sub_ipver = 0;
+
+	/* Loop through available addresses. If the interface is down then it
+	 * is not included in this connection. If the interface is the same as the
+	 * default interface of the connection, it is not included. */
+	for (i = 1; i < mp->mp_conn_address_count; i++) {
+		if (!mp_is_if_up((struct sockaddr *) &mp_usable_addresses[i]) ||
+			mp_is_addr_default((struct sockaddr_in *) &mp_usable_addresses[i],
+			mp)) {
+			mp->mp_advaddr_mask &= ~(1 << i);
+			new_address_count--;
+		}
+		mp->mp_conn_address_count = new_address_count;
+	}
+
+}
+
+
+void
+mp_process_local_key(struct mpcb *mp, uint64_t local_key)
+{
+	uint8_t digest[20];
+	char buf[256];
+
+	mp_do_sha_hash(digest, (uint8_t*) &local_key, sizeof(local_key));
+
+	mp->ds_idsn = mp_new_idsn(digest);
+	mp->local_key = local_key;
+
+	/* As linux does this, we need to do it for interop */
+	mp->ds_idsn = htobe64(mp->ds_idsn);
+	mp->local_token = mp_get_token(digest);
+
+	btohex(buf, sizeof(buf), digest, sizeof(digest), BTOHEX_MSBLTOR);
+	mp_debug(MPSESSION, 4, 0, "SHA1(local_key) = 0x%s\n", buf);
+
+	btohex(buf, sizeof(buf), (uint8_t *)&mp->ds_idsn,
+			sizeof(mp->ds_idsn), BTOHEX_MSBLTOR);
+	mp_debug(MPSESSION, 4, 0, "local idsn = 0x%s\n", buf);
+	mp_debug(MPSESSION, 4, 0, "local idsn = %u\n", (uint32_t)mp->ds_idsn);
+
+}
+void
+mp_process_remote_key(struct mpcb *mp, uint64_t remote_key)
+{
+	uint8_t digest[20];
+	char buf[256];
+
+	mp_do_sha_hash(digest, (uint8_t*) &remote_key, sizeof(remote_key));
+
+	mp->ds_idsr = mp_new_idsn(digest);
+	mp->remote_key = remote_key;
+
+	mp->ds_idsr = htobe64(mp->ds_idsr);
+	mp->remote_token = mp_get_token(digest);
+
+	mp_debug(MPSESSION, 4, 0, "%s: idsr: %ju : %u\n", __func__,
+		(uintmax_t)mp->ds_idsr, (uint32_t)mp->ds_idsr);
+
+	/* debug output from hash */
+	btohex(buf, sizeof(buf), digest, sizeof(digest), BTOHEX_MSBLTOR);
+	mp_debug(MPSESSION, 4, 0, "SHA1(remote_key) = 0x%s\n", buf);
+
+	btohex(buf, sizeof(buf), (uint8_t *)&mp->ds_idsr,
+			sizeof(mp->ds_rcv_nxt), BTOHEX_MSBLTOR);
+	mp_debug(MPSESSION, 4, 0, "remote idsn = 0x%s\n", buf);
+	mp_debug(MPSESSION, 4, 0, "remote idsn = %u\n", (uint32_t)mp->ds_idsr);
+}
+
+
+SYSCTL_VNET_PROC(_net_inet_tcp_mptcp, OID_AUTO, mp_addresses, CTLTYPE_STRING|CTLFLAG_RW,
+    NULL, 0, mp_addresses, "A", "extra addresses to be used in Multipath TCP connections");
+
+SYSCTL_VNET_PROC(_net_inet_tcp_mptcp, OID_AUTO, mp_debug, CTLTYPE_STRING|CTLFLAG_RW,
+    NULL, 0, mp_debug_sysctl_handler, "A", "Enable debugging output for mptcp");
